/**
 * @file
 * VuoList_VuoMidiPitchBend C type definition.
 *
 * @copyright Copyright © 2012–2016 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#pragma once

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoMidiPitchBend VuoList_VuoMidiPitchBend
 * A list of @ref VuoMidiPitchBend elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoMidiPitchBend_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoMidiPitchBend elements.
 */
typedef const struct VuoList_VuoMidiPitchBend_struct { void *l; } * VuoList_VuoMidiPitchBend;
/// @}
#endif

/**
 * Creates a new list of @ref VuoMidiPitchBend elements.
 */
VuoList_VuoMidiPitchBend VuoListCreate_VuoMidiPitchBend(void);

/**
 * Creates a new list of `count` instances of `value`.
 *
 * Use this in conjunction with @ref VuoListGetData_VuoMidiPitchBend to quickly initialize a large list.
 */
VuoList_VuoMidiPitchBend VuoListCreateWithCount_VuoMidiPitchBend(const unsigned long count, const VuoMidiPitchBend value);

/**
 * Makes a shallow copy of `list` — its items are retained (not copied) by the new list.
 */
VuoList_VuoMidiPitchBend VuoListCopy_VuoMidiPitchBend(const VuoList_VuoMidiPitchBend list);

/**
 * Returns the @ref VuoMidiPitchBend at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoMidiPitchBend VuoListGetValue_VuoMidiPitchBend(const VuoList_VuoMidiPitchBend list, const unsigned long index);

/**
 * Returns a pointer to a C array containing the list items.
 *
 * Use this if you need a fast way to get or change multiple list items.
 *
 * You can modify values in the list by changing them in this array.
 * Just don't attempt to access beyond the list size.
 *
 * The pointer becomes invalid if you modify the list size using other functions
 * (e.g., Insert, Prepend, Append, Cut, Remove);
 * if you use those functions, just get a new pointer by calling this function again.
 *
 * If the list has no items, returns NULL.
 *
 * The pointer remains owned by the list; don't free it.
 */
VuoMidiPitchBend *VuoListGetData_VuoMidiPitchBend(const VuoList_VuoMidiPitchBend list);

/**
 * Changes the @ref VuoMidiPitchBend at @c index.
 * Index values start at 1.
 *
 * If `expandListIfNeeded` is false: If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 *
 * If `expandListIfNeeded` is true: If the list has less than `index` elements, it is expanded to accommodate the specified `index`.
 * If `index` is 0, the list is resized to contain 1 item set to `value`.
 */
void VuoListSetValue_VuoMidiPitchBend(const VuoList_VuoMidiPitchBend list, const VuoMidiPitchBend value, const unsigned long index, bool expandListIfNeeded);

/**
 * Inserts the `VuoMidiPitchBend` immediately before `index`.
 * Index values start at 1.
 * Inserting at index 0 prepends the value to the list.
 * Inserting at an index beyond the last value in the list appends the value to the list.
 */
void VuoListInsertValue_VuoMidiPitchBend(const VuoList_VuoMidiPitchBend list, const VuoMidiPitchBend value, const unsigned long index);

/**
 * Prepends @c value to @c list.
 */
void VuoListPrependValue_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list, const VuoMidiPitchBend value);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list, const VuoMidiPitchBend value);

/**
 * Swaps the value at `indexA` with the value at `indexB`.
 */
void VuoListExchangeValues_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list, const unsigned long indexA, const unsigned long indexB);

#ifdef VuoMidiPitchBend_SUPPORTS_COMPARISON
/**
 * Sorts `list`.
 */
void VuoListSort_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list);

/**
 * Returns true if the two lists are equivalent.
 *
 * NULL lists are never equal to non-NULL lists (even empty lists).
 */
bool VuoList_VuoMidiPitchBend_areEqual(const VuoList_VuoMidiPitchBend a, const VuoList_VuoMidiPitchBend b);

/**
 * Returns true if `a` < `b`.
 */
bool VuoList_VuoMidiPitchBend_isLessThan(const VuoList_VuoMidiPitchBend a, const VuoList_VuoMidiPitchBend b);
#endif

/**
 * Generates a random permutation of `list`.
 *
 * `chaos` ranges from 0 to 1.  When `chaos` is 1, a full Fisher–Yates shuffle is performed.  When less than 1, fewer iterations are performed.
 */
void VuoListShuffle_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list, const double chaos);

/**
 * Reverses the order of the items in `list`.
 */
void VuoListReverse_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list);

/**
 * Returns a new list containing items from the original list in the range specified by `startIndex` and `itemCount`.
 *
 * Items in the new list are retained (not copied) from the original list.
 */
VuoList_VuoMidiPitchBend VuoListSubset_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list, const signed long startIndex, const unsigned long itemCount);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list);

/**
 * Removes the `VuoMidiPitchBend` at `index`.
 * Index values start at 1.
 * Attempting to remove index 0 or an index beyond the last value in the list has no effect.
 */
void VuoListRemoveValue_VuoMidiPitchBend(VuoList_VuoMidiPitchBend list, const unsigned long index);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoMidiPitchBend(const VuoList_VuoMidiPitchBend list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoMidiPitchBend VuoList_VuoMidiPitchBend_makeFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoMidiPitchBend_getJson(const VuoList_VuoMidiPitchBend value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoMidiPitchBend_getSummary(const VuoList_VuoMidiPitchBend value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoMidiPitchBend VuoList_VuoMidiPitchBend_makeFromString(const char *str);
char * VuoList_VuoMidiPitchBend_getString(const VuoList_VuoMidiPitchBend value);
/// @}

/**
 * @}
 */
